package com.qizhen.healsphere.repository.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.qizhen.healsphere.repository.mapper.entity.Isolate;
import com.qizhen.healsphere.web.param.GraphInfo;
import com.qizhen.healsphere.web.vo.InputVO;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

public interface IsolateMapper extends BaseMapper<Isolate> {
//
//    @Select("<script>" +
//            "SELECT COUNT(*) FROM public.isolate WHERE 1=1 " +
//            "<if test='constellation != null and constellation.size() > 0'>" +
//            "   AND clade IN <foreach collection='constellation' item='item' open='(' separator=',' close=')'>#{item}</foreach>" +
//            "</if>" +
//            "<if test='subtype != null and subtype != \"\"'>" +
//            "   AND subtype = #{subtype}" +
//            "</if>" +
//            "<if test='isChina != null'>" +
//            "   AND is_china = #{isChina}" +
//            "</if>" +
//            "<if test='startDate != null'>" +
//            "   AND collection_date &gt;= #{startDate}" +
//            "</if>" +
//            "<if test='endDate != null'>" +
//            "   AND collection_date &lt;= #{endDate}" +
//            "</if>" +
//            "</script>")
//    int selectCount(@Param("constellation") List<String> constellation, @Param("subtype") String subtype, @Param("isChina") Integer isChina, @Param("startDate") Date startDate, @Param("endDate") Date endDate);

    // 获取subtype的列表
//    @Select("<script>" +
//            "SELECT " +
//            "  subtype, " +
//            "  STRING_AGG(DISTINCT clade::text, ',') AS clades, " +
//            "  COUNT(1) AS count, " +
//            "  MAX(collection_date) AS cumulative " +
//            "FROM isolate " +
//            "<where> " +
//            "  1=1 " +
//            "  <if test=\"inputVO.subtype != null and inputVO.subtype != ''\"> " + // 使用inputVO.subtype
//            "    AND subtype = #{inputVO.subtype} " +
//            "  </if> " +
//            "  <if test=\"inputVO.startDate != null\"> " +
//            "    AND collection_date >= #{inputVO.startDate} " +
//            "  </if> " +
//            "  <if test=\"inputVO.endDate != null\"> " +
//            "    AND collection_date &lt;= #{inputVO.endDate} " +
//            "  </if> " +
//            "</where> " +
//            "GROUP BY subtype " +
//            "</script>")
//    List<GraphInfo> selectGraphInfo(@Param("inputVO") InputVO inputVO);

        @Select("<script>" +
            "SELECT " +
            "  subtype, " +
            "  STRING_AGG(DISTINCT clade::text, ',') AS clade, " +
            "  COUNT(1) AS count, " +
            "  MAX(collection_date) AS cumulative " +
            "FROM isolate " +
            "<where> " +
            "  1=1 " +
            "  <if test=\"inputVO.subtype != null and inputVO.subtype != ''\"> " + // 使用inputVO.subtype
            "    AND subtype = #{inputVO.subtype} " +
            "  </if> " +
            "  <if test=\"inputVO.startDate != null\"> " +
            "    AND collection_date >= #{inputVO.startDate} " +
            "  </if> " +
            "  <if test=\"inputVO.endDate != null\"> " +
            "    AND collection_date &lt;= #{inputVO.endDate} " +
            "  </if> " +
            "</where> " +
            "GROUP BY subtype " +
            "</script>")
    public List<GraphInfo> selectGraphInfo(@Param("inputVO")InputVO inputVO);
}
