package com.qizhen.healsphere;

import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpUtil;
import cn.hutool.http.Method;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.qizhen.healsphere.common.ai.QizhenAssistant;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class ExplainAssistant {

    public static String getConversationId(String appId) {
        JSONObject json = new JSONObject();
        json.put("app_id", appId);
        //json.put("app_id", "454b1634-91ad-4dde-9d2f-f9a3302fdcbe");
        HttpRequest request = HttpUtil.createRequest(Method.POST, "https://qianfan.baidubce.com/v2/app/conversation")
                .header("Authorization", "Bearer bce-v3/ALTAK-MyGbNEA18oT3boS2nOga1/d8b5057f7842f59b2c64971d8d077fe724d0aed5")
                .header("Content-Type", "application/json")
                .body(json.toJSONString());
        ;
        String resposne = request.execute().body();
        return JSONObject.parseObject(resposne).getString("conversation_id");
    }

    public static String call(String appId, String conversationId, String userInput){
        JSONObject json = new JSONObject();
        json.put("app_id", appId);
        json.put("conversation_id", conversationId);
        json.put("query", userInput);
        json.put("stream", false);


        HttpRequest request = HttpUtil.createRequest(Method.POST, "https://qianfan.baidubce.com/v2/app/conversation/runs")
                .header("Authorization", "Bearer bce-v3/ALTAK-MyGbNEA18oT3boS2nOga1/d8b5057f7842f59b2c64971d8d077fe724d0aed5")
                .header("Content-Type", "application/json")
                .body(json.toJSONString()).timeout(120 * 1000);
        long l = System.currentTimeMillis();
        String resposne = request.execute().body();
        System.out.println(userInput.length());
        long ct = (System.currentTimeMillis() - l) / 1000;
        System.out.println(ct);
        System.out.println(userInput.length()/ct);
        System.out.println("===========================");
        return resposne;
    }

    public static void main(String[] args) {
        HttpUtil.createRequest(Method.POST, "http://localhost:8086/healsphere/info?input=Prymnesium").execute();
    }

}
