package com.qizhen.healsphere.repository.mapper.entity;


import com.baomidou.mybatisplus.annotation.*;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

@Data
@TableName("isolate")
public class Isolate implements Serializable {

    /**
     * 主键
     */
    @TableId(value = "isolate_id")
    private String isolateId;

    /**
     * 病毒名称
     */
    @TableField("isolate_name")
    private String isolateName;

    /**
     * 采集日期
     */
    @TableField(value = "collection_date")
    private Date collectionDate;

    /**
     * 提交日期
     */
    @TableField(value = "submission_date")
    private Date submissionDate;

    /**
     * 更新日期
     */
    @TableField(value = "update_date")
    private Date updateDate;

    /**
     * 亚型
     */
    @TableField("subtype")
    private String subtype;

    /**
     * 基因型
     */
    @TableField("genotype")
    private String genotype;

    /**
     * 谱系
     */
    @TableField("lineage")
    private String lineage;

    /**
     * 进化分支
     */
    @TableField("clade")
    private String clade;

    /**
     * 地理来源
     */
    @TableField("location")
    private String location;

    /**
     * 宿主外键
     */
    @TableField("host_id")
    private String hostId;
}
